<template>
  <div>
    <v-dialog
      v-model="showDialog"
      max-width="630"
      persistent
      v-if="processType !== 'delete'"
    >
      <v-card>
        <v-card-title>{{
          processType === "add"
            ? "Add " + tagType + " tag"
            : "Edit " + item?.name
        }}</v-card-title>
        <v-divider></v-divider>
        <v-container>
          <v-row no-getters align="center">
            <v-col cols="11" class="mx-3">
              <v-form v-model="valid" class="row py-2 px-4" ref="form">
                <v-text-field
                  class="col-6 mt-6"
                  label="Tag name"
                  v-model="tagName"
                  required
                  dense
                  :rules="[v => !!v || 'Name is required']"
                >
                </v-text-field>
                <v-select
                  class="col-6 mt-6"
                  v-model="selectedTenants"
                  label="Tenants"
                  :items="$store.state.application.tenants"
                  item-text="name"
                  item-value="tenant_id"
                  dense
                  return-object
                  persistent-hint
                  multiple
                  required
                  small-chips
                  deletable-chips
                  :rules="[
                    v => !!(v && v.length) || 'Selecting tenant(s) is required'
                  ]"
                  hint="Assign Tag to specific tenant(s)"
                ></v-select>
                <v-switch
                  dense
                  class="pl-3"
                  v-model="isVisible"
                  label="Visibility"
                  persistent-hint
                  hint="Turn on/off the visibility of tag to orga-admin(s)"
                >
                </v-switch>
              </v-form>
            </v-col>
          </v-row>
        </v-container>
        <v-divider class="mt-2"></v-divider>
        <v-card-actions class="justify-end">
          <UIAlert
            class="mt-4"
            v-if="hasRequestError"
            v-bind:isSuccessful="!hasRequestError"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <div
            class="d-flex align-center pa-1"
            v-if="confirmTenantDeletion && !hasRequestError"
          >
            <div class="error--text">
              Removing
              <span
                class="font-weight-medium"
                v-for="t in removedTenants"
                :key="t.tenant_id"
              >
                {{ t.name }}
              </span>
              could affect
              {{
                tagType === "contact"
                  ? contactAmount + " contact(s)"
                  : affectedElements + " organisation(s)"
              }}
              , this process is not easily revertable, please confirm/deny this.
            </div>
            <v-btn
              color="blue darken-1"
              @click="
                selectedTenants = originalTenants;
                confirmTenantDeletion = false;
              "
              text
              >deny</v-btn
            >
            <v-btn color="blue darken-1" @click="confirmEditing" text
              >confirm</v-btn
            >
          </div>
          <div class="d-flex" v-else>
            <v-btn
              color="blue darken-1"
              text
              @click="
                form.reset();
                $emit('child-object', { closeDialog: true, tagChanged: false });
              "
            >
              Cancel
            </v-btn>
            <v-btn
              v-if="processType === 'add'"
              color="blue darken-1"
              text
              :disabled="!valid"
              @click="addTag()"
            >
              Add
            </v-btn>
            <v-btn
              v-else
              color="blue darken-1"
              text
              :disabled="!valid"
              @click="checkTenantsForUpdate()"
            >
              update
            </v-btn>
          </div>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="showDialog" max-width="630" v-else>
      <v-card>
        <v-card-title class="headline"
          >Are you sure you want to delete
          {{ item ? item.name : "" }}?</v-card-title
        >
        <v-card-actions>
          <UIAlert
            class="mt-4"
            v-if="hasRequestError"
            v-bind:isSuccessful="!hasRequestError"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', { closeDialog: true, tagChanged: false })
            "
            >close</v-btn
          >
          <v-btn color="blue darken-1" text @click="confirmDeletion">yes</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script lang="ts" setup>
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { HTTP } from "@/lib/http";
import { useForm } from "@/lib/use-form";
import { useNotification } from "@/lib/use-notification";
import { computed, defineAsyncComponent, onMounted, ref } from "vue";

const props = defineProps({
  item: Object,
  processType: String,
  tagType: String
});
const emit = defineEmits(["child-object"]);

const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const showDialog = true;
const { form, valid } = useForm();
const { hasRequestError } = useNotification();
const isLoading = ref(false);
const tagName = ref();
const selectedTenants = ref();
const isVisible = ref(false);
// Add Tag
const addTag = () => {
  isLoading.value = true;
  HTTP.post(
    props.tagType === "organisation" ? "/organisation_tags" : "/contact_tags",
    {
      name: tagName.value,
      visible: isVisible.value,
      tenants: selectedTenants.value.map(t => t.tenant_id)
    }
  )
    .then(() => {
      isLoading.value = false;
      emit("child-object", { closeDialog: true, tagChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    });
};
const routeForRequests = computed(() => {
  return props.tagType === "organisation"
    ? `/organisation_tags/${props.item?.organisation_tag_id}`
    : `/contact_tags/${props.item?.contact_tag_id}`;
});
// Delete Tag
const confirmDeletion = () => {
  isLoading.value = true;
  HTTP.delete(routeForRequests.value)
    .then(() => {
      isLoading.value = false;
      emit("child-object", { closeDialog: true, tagChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    });
};
// Update Tag
const removedTenants = ref();
const originalTenants = ref();
const contactAmount = ref();
const affectedElements = ref();
const confirmTenantDeletion = ref(false);
const setInitialValues = () => {
  tagName.value = props.item?.name || "";
  isVisible.value = props.item?.visible || false;
  selectedTenants.value = props.item?.tenants || [];
  originalTenants.value = props.item?.tenants || [];
};
// Check if tenant(s) is/are removed from the tag to ask for
// further confirmation as this should be handled carefully
const checkTenantsForUpdate = () => {
  removedTenants.value = originalTenants.value.filter(
    t => selectedTenants.value.indexOf(t) === -1
  );
  if (removedTenants.value && removedTenants.value.length) {
    if (props.tagType === "organisation") {
      getOrganisations();
    } else {
      getContacts();
    }
    confirmTenantDeletion.value = true;
  } else {
    confirmEditing();
  }
};
const confirmEditing = () => {
  isLoading.value = true;
  HTTP.put(routeForRequests.value, {
    name: tagName.value,
    visible: isVisible.value,
    tenants: selectedTenants.value.map(t => t.tenant_id)
  })
    .then(() => {
      emit("child-object", {
        ruleChanged: true
      });
      emit("child-object", { closeDialog: true, tagChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      form.value.reset();
      isLoading.value = false;
    });
};
const getOrganisations = () => {
  HTTP.get("/organisations?page=10&tag=" + props.item?.organisation_tag_id)
    .then(response => {
      affectedElements.value = response.data.meta.total;
    })
    .catch(() => {
      hasRequestError.value = true;
    });
};
const getContacts = () => {
  HTTP.get("/contacts?page=10&tag=" + props.item?.contact_tag_id)
    .then(response => {
      contactAmount.value = response.data.total;
    })
    .catch(() => {
      hasRequestError.value = true;
    });
};
onMounted(() => {
  if (props.processType === "edit") {
    setInitialValues();
  }
});
</script>
